package jlowplugin;

import java.awt.*;
import java.net.URL;
import java.util.Hashtable;

import javax.swing.*;

import cds.jlow.client.descriptor.*;
import cds.jlow.descriptor.*;
import cds.jlow.client.net.service.IListService;
import cds.jlow.client.util.ToStringModule;
import cds.jlow.client.view.*;
import cds.jlow.util.*;


/**
 * @author Cyril Pestel
 * @version 0.1
 */
public class AladinListService implements IListService {
	
	/**
	 * Load the list of tasks.
	 */
	public boolean load(IRegisterer register) {
		
//		Name of the service use in server
		String service = "Aladin";
		

		/*
		String loadID = "Load data/Export data";
		Color cSal = new Color(141, 90, 99);
		String idAtts = "";
		
		Attributs atts = new Attributs(idAtts, loadID, cSal, new Dimension(80, 100));
		atts.putAtt(Attributs.GRADIENTCOLOR, new GradientPaint(0, 0, cSal, 175,
				175, new Color(255, 255, 255, 200), true));
		register.addAtt(atts);
		*/

//		---------------------- types de données --------------------------
		
		// *** ATTRIBUT TYPE TASK *** \\
		String idTTask = "java.task";
		Attributs taskAtts = AttributsFactory.newTaskAttributs(idTTask, "Task", 
				new Color(99, 141, 99, 220));
		taskAtts.setSize(new Dimension(120,100));
		register.addAtt(taskAtts);
		
		// *** ATTRIBUT TYPE INTEGER *** \\
		String idTInteger = "java.integer";
		Color cInteger = new Color(50, 100, 100, 220);
		Attributs typeIntegertype =AttributsFactory.newPortAttributs(idTInteger, Type.INTEGERNAME, cInteger);
		register.addAtt(typeIntegertype);
		
//		 *** ATTRIBUT TYPE STRING *** \\
		String idTString = "java.string";
		Color cString = new Color(130, 132, 62, 220);
		/*
		Attributs typeStringtype = new Attributs(idTString, Type.STRINGNAME, cString, new Dimension(20,20));
		
		typeStringtype.putAtt("border", BorderFactory.createRaisedBevelBorder());
		typeStringtype.putAtt("font", new Font("Monospaced", Font.PLAIN, 10));
		*/
		Attributs typeStringtype =AttributsFactory.newPortAttributs(idTString, Type.STRINGNAME, cString);
		register.addAtt(typeStringtype);
		
//		 *** ATTRIBUT TYPE PLANE *** \\
		String idTPlane = "java.plane";
		Color cPlane = new Color(204, 255, 203, 220);
		/*
		Attributs typePlanetype = new Attributs(idTPlane, "Plane", cPlane, new Dimension(20,20));
		
		typePlanetype.putAtt("border", BorderFactory.createRaisedBevelBorder());
		typePlanetype.putAtt("font", new Font("Monospaced", Font.PLAIN, 10));
		*/
		Attributs typePlanetype =AttributsFactory.newPortAttributs(idTPlane, "Plane", cPlane);
		register.addAtt(typePlanetype);
		
		//TYPE PLANE
		Type tPlane = new Type("Plane:*");
		
//		 *** ATTRIBUT TYPE PLANE IMAGE *** \\
		String idTPlaneImage = "java.plane.image";
		Color cPlaneImage = new Color(162, 121, 158, 220);

		Attributs typePlaneImagetype =AttributsFactory.newPortAttributs(idTPlaneImage, "PlaneImage", cPlaneImage);
		register.addAtt(typePlaneImagetype);
		
		//TYPE PLANE
		Type tPlaneImage = new Type("Plane:image");
		
//		 *** ATTRIBUT TYPE PLANE DATA *** \\
		String idTPlaneData = "java.plane.data";
		Color cPlaneData = new Color(121, 162, 142, 220);

		Attributs typePlaneDatatype =AttributsFactory.newPortAttributs(idTPlaneData, "PlaneImage", cPlaneData);
		register.addAtt(typePlaneDatatype);
		
		//TYPE PLANE
		Type tPlaneData = new Type("Plane:data");
		
		// *** ATTRIBUT TYPE COLOR *** \\
		String idTColor = "java.color";
		Color cColor = new Color(100, 60, 50, 220);
		Attributs typeColortype =AttributsFactory.newPortAttributs(idTColor, "Color", cColor);
		register.addAtt(typeColortype);
		
		//TYPE Color
		Type tColor = new Type("Color"); //Uppercase or not ??

		// *** ATTRIBUT TYPE FLOAT *** \\
		String idTFloat = "java.float";
		Color cFloat = new Color(242, 187, 39, 220);
		Attributs typeFloattype =AttributsFactory.newPortAttributs(idTFloat, "Float", cFloat);
		register.addAtt(typeFloattype);
		
		//TYPE PLANET
		Type tFloat = new Type("Float");

		
		
//		---------------------- descripteurs relatifs aux chargement d'objets --------------------------
		idTTask = "java.task.load";
		taskAtts = AttributsFactory.newTaskAttributs(idTTask, "Load Data", 
				new Color(99, 141, 99, 220));
		taskAtts.setSize(new Dimension(120,100));
		
		register.addAtt(taskAtts);
		
//		 **** get Local ****
		String itemtask = "Load from local";
		String nametask = "Load Local";//"<html><center>Load <br>Local Data</center></html>";
		//int nCalcul = 0;
		String idtask = "get_local"; //Regex : name of the command
		//Hashtable<String, DefaultModule> mods = new Hashtable<String, DefaultModule>(); //Java 5.0
		Hashtable mods = new Hashtable(); //Java 1.4
		mods.put("tostring", new ToStringModule());
		mods.put("tohtml", new jlowplugin.ui.util.ToHtmlModule());
		
		
		TaskDescriptor desc = new TaskDescriptor(itemtask, nametask, mods);
		// TODO : ne fonctionne pas
//		desc.putOpt("cmdid", "get Local");
		desc.putAtt("cmd", "get");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Load an image or a tabular data file");

		URL imageURL = this.getClass().getResource("/images/i-directory.png");
		
		Attributs localAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			localAtts.putAtt("icon", new ImageIcon(imageURL));
		localAtts.setId(taskAtts.getId()+".local");
		register.addAtt(localAtts);
		
		register.add(desc, localAtts); 
		
		
		String namePort = "file name";
		//String idPort = Utils.getIdUnique();
		String idPort = createPortID(idtask,namePort); 
		PortDescriptor port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING,new String()),
				mods); 
		
		 
		FileViewModule fileviewmod = new FileViewModule(port.getData(),""); 
		JButton filechooserb = (JButton) fileviewmod.createView().get(3);
		
		Action filechoosera = filechooserb.getAction();
		
		imageURL = this.getClass().getResource("/images/desktop-home-25.png");
		if(imageURL!=null)
			filechoosera.putValue(Action.SMALL_ICON, new ImageIcon(imageURL));
		
		port.getData().putModule("view", fileviewmod); 
		
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);
		
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlane), mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlane);
		
//		 **** get Aladin ****
		itemtask = "Load image from Aladin server";
		nametask = "Load Image";//"<html><center>Load <br>Image</center></html>";
		idtask = "get_aladin";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "get");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Load an image from Aladin server");
		
		imageURL = this.getClass().getResource("/images/aladin_icon.gif");
		
		Attributs aladinAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			aladinAtts.putAtt("icon", new ImageIcon(imageURL));
		aladinAtts.setId(taskAtts.getId()+".aladin");
		register.addAtt(aladinAtts);
		
		register.add(desc, aladinAtts);
		//register.put(itemtask, desc, (Attributs) taskAtts.clone());
		
		namePort = "target";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING), // Ex. taurus
				mods);
		port.setOrder(0);
		//port.getData().putModule("view", new StringViewModule());
		port.getData().putModule("view", new ComboBoxModule()); 
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);
		
		namePort = "survey";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String()), // Ex. 2MASS
				mods);
		port.setOrder(1);
		port.setOptional(true);
//		port.getData().putModule("view", new StringViewModule());
		port.getData().putModule("view", new ComboBoxModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);
		 
		namePort = "color";
		//idPort = Utils.getIdUnique(); 
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tColor, new String()), // Ex. J
				mods);
		port.setOrder(2);
		port.setOptional(true);
		//port.getData().putModule("view", new StringViewModule());
		port.getData().putModule("view", new ComboBoxModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTColor);

		namePort = "format";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String("JPEG")), // Ex. J
				mods); 
		port.setOrder(3);
		port.setOptional(true);
		//port.getData().putModule("view", new StringViewModule());
		port.getData().putModule("view", new RadioButtonModule(new String[]{"JPEG","FITS"}));
		 
		desc.addInputPort(idPort);
		
		register.add(port, idTColor);
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneImage), mods);
		port.setOrder(0);
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
//		 **** get Simbad ****
		itemtask = "Load data from Simbad";
		nametask = "Load Simbad Data";//"<html><center>Load <br>Data</center></html>";
		idtask = "get_simbad";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "get");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Load data from Simbad");
		
		imageURL = this.getClass().getResource("/images/simbad_icon.gif");
		
		Attributs simbadAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			simbadAtts.putAtt("icon", new ImageIcon(imageURL));
		simbadAtts.setId(taskAtts.getId()+".simbad");
		register.addAtt(simbadAtts);
		
		register.add(desc, simbadAtts);
		//register.put(itemtask, desc, (Attributs) taskAtts.clone());
		
		namePort = "target";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String()),
				mods);
		port.setOrder(0);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);

		namePort = "radius";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tFloat, new String("10.0'")),
				mods);
		port.setOrder(1);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTFloat);
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneData), mods);
		port.setOrder(0);
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneData);
		
//		 **** get VizieR ****
		itemtask = "Load data from VizieR";
		nametask = "Load Vizier Data";//"<html><center>Load <br>Catalogue</center></html>";
		idtask = "get_vizier";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "get");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Load data from VizieR");

		imageURL = this.getClass().getResource("/images/vizier_logo.gif");
		
		Attributs vizierAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			vizierAtts.putAtt("icon", new ImageIcon(imageURL));
		vizierAtts.setId(taskAtts.getId()+".vizier");
		register.addAtt(vizierAtts);
		
		register.add(desc, vizierAtts);
		
		namePort = "target";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String()),
				mods);
		port.setOrder(0);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);
		
		namePort = "catalogue";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String()),
				mods);
		port.setOrder(1);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);

		namePort = "radius";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tFloat, new String("10.0'")),
				mods);
		port.setOrder(2);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTFloat);
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneData), mods);
		port.setOrder(0);
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneData);

		
//		 **** get NED ****
		itemtask = "Load data from NED server";
		nametask = "Load NED Data";//"<html><center>Load <br>Image</center></html>";
		idtask = "get_ned";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "get");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Load data from NED server");
		
		imageURL = this.getClass().getResource("/images/nedlogo.png");
		//imageSt = "nedlogo.png";
		
		Attributs nedAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			nedAtts.putAtt("icon", new ImageIcon(imageURL));
		nedAtts.setId(taskAtts.getId()+".ned");
		register.addAtt(nedAtts);
		
		register.add(desc, nedAtts);
		
		namePort = "target";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String()),
				mods);
		port.setOrder(0);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);
		
		namePort = "radius"; //TODO: add Float Type and FloatViewModule
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tFloat,
						new String("14.0'")),
				mods);
		port.setOrder(1);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTFloat);
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneData), mods);
		port.setOrder(0);
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneData);


//		---------------------- descripteurs relatifs à la sauvegarde de plan --------------------------
		idTTask = "java.task.save";
		taskAtts = AttributsFactory.newTaskAttributs(idTTask, "Save", 
				new Color(99, 141, 99, 220));
		taskAtts.setSize(new Dimension(120,100));
		register.addAtt(taskAtts);
		
//		 **** Export ****
		itemtask = "Export a plane";
		nametask = "Export Plane";//"<html><center>Export <br>Plane</center></html>";
		idtask = "export";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "export");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Save images or tabular data");

		imageURL = this.getClass().getResource("/images/export_icon.gif");
		
		Attributs exportAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			exportAtts.putAtt("icon", new ImageIcon(imageURL));
		exportAtts.setId(taskAtts.getId()+".export");
		register.addAtt(exportAtts);
		
		register.add(desc, exportAtts);
		//register.put(itemtask, desc, (Attributs) taskAtts.clone());
		
		namePort = "plane name";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlane),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlane);

		namePort = "file name";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String()),
				mods);
		port.setOrder(0);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);
		
		namePort = "format";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.STRING, new String()),
				mods);
		port.setOrder(1);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTString);
		
//		---------------------- descripteurs relatifs aux traitements d'images --------------------------
		
		
		idTTask = "java.task.image";
		taskAtts = AttributsFactory.newTaskAttributs(idTTask, "Image Tools", 
				new Color(141, 99, 99, 220));
		taskAtts.setSize(new Dimension(120,100));
		register.addAtt(taskAtts);
		
//		 **** rgb ****
		itemtask = "RGB Color composition";
		nametask = "RGB";//"<html><center>RGB</center></html>";
		idtask = "rgb";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "RGB");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Create a RGB image");

		imageURL = this.getClass().getResource("/images/rgb_icon.gif");
		
		Attributs rgbAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			rgbAtts.putAtt("icon", new ImageIcon(imageURL));
		rgbAtts.setId(taskAtts.getId()+".rgb");
		register.addAtt(rgbAtts);
		
		register.add(desc, rgbAtts);
		//register.put(itemtask, desc, (Attributs) taskAtts.clone());
		
		namePort = "red component";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
		namePort = "green component";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		//System.out.println("Data : "+port.getData().getData());
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
		namePort = "blue component";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneImage), mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneImage);
		

		
//		 **** contour ****
		itemtask = "Compute isocontours";
		nametask = "Contour";//"<html><center>Contour</center></html>";
		idtask = "contour";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "contour");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Draw isocontours to an image");

		imageURL = this.getClass().getResource("/images/isocontour_icon.png");
		//imageSt = "isocontour_icon.png";
		
		Attributs contourAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			contourAtts.putAtt("icon", new ImageIcon(imageURL));
		contourAtts.setId(taskAtts.getId()+".contour");
		register.addAtt(contourAtts);
		
		register.add(desc, contourAtts);
		
		namePort = "plane name";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
		namePort = "number of contours";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(Type.INTEGER, new Integer(4)),
				mods);
		//port.putAtt("Commentaire", "Number of contours");
		port.getData().putModule("view", new IntegerViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTInteger);
		
//		 **** blink ****
		itemtask = "Blink sequence";
		nametask = "Blink";//"<html><center>Blink</center></html>";
		idtask = "blink";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "blink");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Create a blink sequence of images");

		imageURL = this.getClass().getResource("/images/blink_icon.gif");
		//imageSt = "blink_icon.gif";
		
		Attributs blinkAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			blinkAtts.setIcon( new ImageIcon(imageURL));
//			blinkAtts.putAtt("icon", new ImageIcon(imageURL));
		blinkAtts.setId(taskAtts.getId()+".blink");
		register.addAtt(blinkAtts);
		
		register.add(desc, blinkAtts);
		
		namePort = "1st component";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
		namePort = "2nd component";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
		namePort = "3th component";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneImage);
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneImage), mods);
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneImage);

//		 **** sextractor ****
		itemtask = "Sextractor";
		nametask = "Sextractor";//"<html><center>XMatch</center></html>";
		idtask = "get_sextractor";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "get");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Extract data from an image");

		imageURL = this.getClass().getResource("/images/sextractor_icon.png");
		//imageSt = "sextractor_icon.png";
		
		Attributs sextractorAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			sextractorAtts.setIcon( new ImageIcon(imageURL));
//			sextractorAtts.putAtt("icon", new ImageIcon(imageURL));
		sextractorAtts.setId(taskAtts.getId()+".sex");
		register.addAtt(sextractorAtts);
		
		register.add(desc, sextractorAtts);
		
		namePort = "image plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneImage),
				mods);
		
		desc.addInputPort(idPort);
		
		//Type Planet
		register.add(port, idTPlaneImage);
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneData), mods);
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneData);
	
//		---------------------- descripteurs relatifs aux traitements sur catalogues --------------------------
		idTTask = "java.task.cat";
		taskAtts = AttributsFactory.newTaskAttributs(idTTask, "Catalogue Tools", 
				new Color(141, 141, 99, 220));
		taskAtts.setSize(new Dimension(120,100));
		register.addAtt(taskAtts);
		
//		 **** xmatch ****
		itemtask = "Cross-match";
		nametask = "XMatch";//"<html><center>XMatch</center></html>";
		idtask = "xmatch";
		desc = new TaskDescriptor(itemtask, nametask, mods);
		desc.putAtt("cmd", "xmatch");
		desc.putAtt("service", service);
		desc.putAtt("comment", "Cross match two tabular data");

		imageURL = this.getClass().getResource("/images/xmatch_icon.gif");
		
		Attributs xmatchAtts = (Attributs) taskAtts.clone();
		if(imageURL!=null)
			xmatchAtts.putAtt("icon", new ImageIcon(imageURL));
		xmatchAtts.setId(taskAtts.getId()+".xmatch");
		register.addAtt(xmatchAtts);
		
		register.add(desc, xmatchAtts);
		//register.put(itemtask, desc, (Attributs) taskAtts.clone());
		
		
		namePort = "1st catalogue";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneData),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneData);
		
		namePort = "2nd catalogue";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tPlaneData),
				mods);
		//port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTPlaneData);
		
		namePort = "max dist"; //(in arsec)
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.INPUT,
				new Constant(tFloat,
						new String("4.0")), //Float
				mods);
		port.getData().putModule("view", new StringViewModule());
		
		desc.addInputPort(idPort);
		
		register.add(port, idTFloat); //TODO : put float == FloatViewModule
		
		namePort = "result plane";
		//idPort = Utils.getIdUnique();
		idPort = createPortID(idtask,namePort);
		port = new PortDescriptor(idPort, namePort, IPortDescriptor.OUTPUT,
				new Constant(tPlaneData), mods);
		
		desc.addOutputPort(idPort);
		
		register.add(port, idTPlaneData);
		
//		---------------------- descripteurs relatifs aux autres traitements --------------------------
		/*
		idTTask = "java.task.other";
		taskAtts = AttributsFactory.newTaskAttributs(idTTask, "OtherTask", 
				new Color(141, 70, 99, 220));
		taskAtts.setSize(new Dimension(120,100));
		register.addAtt(taskAtts);
		*/

		
//		---------------------- descripteurs de données --------------------------
		
		Color emptyColor = Color.BLACK;

		//Color cData = new Color(92, 94, 149, 200);// new Color(219,219,224);
		String iddatacat = "java.data.simple";
		//String iddatacat = "org." + namedata;
		Attributs dataintatts = new Attributs(iddatacat, "Simple", cString,
				new Dimension(50, 50));
		dataintatts.putAtt(Attributs.GRADIENTCOLOR, new GradientPaint(0, 0,
				cString, 175, 175, Color.BLACK, true));
		
		
//		dataintatts.putAtt(Attributs.EMPTYDATACOLOR, emptyColor);
		dataintatts.putAtt(Attributs.FILLDATACOLOR, cString.brighter());
//		dataintatts.putAtt(Attributs.DRAWCOLOR, emptyColor);
		
		register.putAtt(iddatacat, dataintatts);

		String namedata = "numeric";
		String iddata = "com.data." + namedata;
/*		IntegerDescriptor intdesc = new IntegerDescriptor(iddata, mods);
		
		intdesc.putModule("view", new IntegerViewModule());
		
		register.add(intdesc, dataintatts);
		*/
		namedata = "string";
		iddata = "com.data." + namedata;
		StringDescriptor strdesc = new StringDescriptor(iddata, null, mods);
		
		strdesc.putModule("view", new ComboBoxModule());
		
		Color cnewString = new Color(cString.getRed(), cString.getGreen(), cString.getBlue(), 70);
		
		Attributs datastratts = (Attributs) dataintatts.clone();
		datastratts.putAtt(Attributs.GRADIENTCOLOR, new GradientPaint(0, 0,
				cString, 175, 175, Color.BLACK, true));
		datastratts.putAtt(Attributs.DRAWCOLOR, cnewString
				);
		
		dataintatts.putAtt(Attributs.FILLDATACOLOR, cnewString);
		
		register.add(strdesc, datastratts);
		
		return true;
	}
	
	public String createPortID(String taskID, String name) {
		
		return taskID+"."+name;
	}
	
	
}
