package jlowplugin.server;

import java.io.IOException;

import jlowplugin.server.event.ScriptWRListener;
import jlowplugin.ui.ScriptPane;

//import jlowplugin.server.service.*;

import cds.jlow.descriptor.IRegister;
import cds.jlow.descriptor.Register;
import cds.jlow.server.motor.WorkManager;
import cds.jlow.server.motor.WorkRegister;
import cds.jlow.server.net.server.ServerManager;
import cds.jlow.server.net.server.ServerRegister;
import cds.jlow.server.net.service.ServiceRegisterer;
import cds.jlow.server.sample.socket.ObjectServer;
import cds.jlow.server.sample.socket.SocketServer;

public class JlowServer implements Runnable {
	
	//private Aladin aladin;
	protected ServiceRegisterer services;
	protected ServerManager servermanager;
	
	protected WorkManager workmanager;
	protected IRegister descregister;
	
	protected boolean actif;
	
	public JlowServer() {
		services = new ServiceRegisterer();
		//Creates the manager for IServer 
		servermanager = new ServerManager();

		//Creates a register and a manager for works
		descregister = new Register();
		workmanager = new WorkManager(new WorkRegister(), services, descregister);
		
		actif = false;
	}
	
	public JlowServer(ServiceRegisterer register) {
		services = register;
	}
	
	public void run() {
		//////////SERVICE FOR SOCKETSERVER /////////////////
		SocketServer sockserver = new SocketServer();		
		
//		Creates an ObjectRegister
		
		//My personal server must be know this manager (@see addClient)
		sockserver.setManager(workmanager);
		
		
		////////// SERVICE FOR OBJECTSERVER //////////////////
		
		ObjectServer objserver = new ObjectServer(2122);
		//servregister = sockserver.getRegister();
		
		objserver.setDescriptorRegister(descregister);
//		Create an ObjectService and add it into the service register
		
		////////////////SERVER ///////////////
		
		//Stores the SocketServer
		ServerRegister serverregister = servermanager.getServerRegister();
		serverregister.put(sockserver,sockserver);
		
//		Stores the ObjectServer
		serverregister.put(objserver,objserver);
		
		try {
			//Put on the servers
			servermanager.on();
			actif = true;
		}
		catch (IOException ioe) {
			
			//Put off the servers
			try {
				servermanager.off();
				actif = false;
			}
			catch (IOException e) {
			}
		}
	}

	public boolean isActif() {
		return actif;
	}
	
	public void setServices(ServiceRegisterer register) {
		services = register;
	}
	
}
