package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.aladin.Tok;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.*;


public class Blink extends AbstractService {

	public static int next = 0;
	public Aladin aladin;

	private ScriptPane scriptPane;
	
	public Blink(Aladin aladin) {
		this(aladin, null);
	}
	
	public Blink(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();

		String first = (String) params.get("1st component");
		String second = (String) params.get("2nd component");
		String third = (String) params.get("3th component");
		
		if(first==null || second==null || third==null)
			return null;
		
		String planename = "Blink"+((next>0) ? "~"+next : "");
		next++;
		
		String cmd = "sync; blink "+Tok.quote(first)+" "+Tok.quote(second)+" "+Tok.quote(third);
		String error = aladin.execCommand(cmd);
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(error!=null && !error.trim().equals(""))
			System.out.println(error);
		
		table.put("result plane", planename);
		
		return table;
	}
	
//	public String quote(String s) {
//      char a[] = s.toCharArray();
//      for( int i=0; i<a.length; i++ ) {
//         if( Character.isWhitespace(a[i]) ) return "\""+s+"\"";
//      }
//      return s;
//   }

}
