package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.aladin.Tok;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.AbstractService;
import cds.jlow.server.net.service.IService;

public class Export extends AbstractService {

	public Aladin aladin;

	private ScriptPane scriptPane;
	
	public Export(Aladin aladin) {
		this(aladin, null);
	}

	public Export(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();

		String planename = (String) params.get("plane name");
		String fmt = (String) params.get("fmt");
		String filename = (String) params.get("file name");
		
		if(planename==null || filename==null)
			return null;
		
		String cmd = "sync; export ";
		if(fmt!=null && !fmt.trim().equals(""))
			cmd = cmd + "-" + fmt + " ";
		cmd = cmd + Tok.quote(planename)+" "+filename;
		
		String id = aladin.execCommand(cmd);
		
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(id!=null && !id.trim().equals(""))
			System.out.println("Error :"+id);
		
		return table;
	}

//	public String quote(String s) {
//		char a[] = s.toCharArray();
//		for (int i = 0; i < a.length; i++) {
//			if (Character.isWhitespace(a[i]))
//				return "\"" + s + "\"";
//		}
//		return s;
//	}
}
