package jlowplugin.server.service;

import java.io.ByteArrayOutputStream;
import java.io.StringWriter;
import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.AbstractService;
import cds.jlow.server.net.service.IService;

public class GetAladin extends AbstractService {

	public static Aladin aladin;
	private ScriptPane scriptPane;
	
	public GetAladin(Aladin aladin) {
		this(aladin, null);
	}
	
	public GetAladin(Aladin aladin, ScriptPane s) {
		GetAladin.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();

//		String task = desc.getName();
//		Object result = null;

		String target = (String) params.get("target");
		String survey = (String) params.get("survey");
		String color = (String) params.get("color");
		String format = (String) params.get("format");
		
		if(target==null) {
			System.out.println("GetAladin: target of getAladin null");
			return null;
		}
		
		// ** Creates the command line and plane name
		String planename = target;
		String cmd = "get Aladin(";
		//Keyword
		boolean follow = false;
		
		if(survey!=null && !survey.trim().equals("")) {
			cmd += survey;
			planename += "."+survey;
			follow=true;
		}
		
		if(color!=null && !color.trim().equals("")) {
			cmd += (follow ? "," : "")+color;
			planename += "."+color;
			follow = true;
		}

		if(format!=null && !format.trim().equals("")) {
			cmd += (follow ? "," : "")+format;
			planename += "."+format;
		}
		
		cmd += ") ";
		
		//Target
		cmd += target;
		
		//Change name
		cmd = planename+"="+cmd;
		
		// ** Executes the command line
		String id = aladin.execCommand(cmd);
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(id!=null && !id.trim().equals(""))
			System.out.println("Aladin error : "+id);

		System.out.println("planename : "+planename);
		
		if(planename!=null)
			table.put("result plane", planename);
		else
			return null; //Else there is a problem
		
		return table;
	}
}
