package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.*;

public class GetVizier extends AbstractService {

	public Aladin aladin;

	private ScriptPane scriptPane;
	
	public GetVizier(Aladin aladin) {
		this(aladin, null);
	}

	public GetVizier(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}
	
	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();
		
		String target = (String) params.get("target");
		String cat = (String) params.get("catalogue");
		String radius = (String) params.get("radius");
		
		if(target==null || cat==null)
			return null; 
		
		// ** Creates the command line and plane name
		String planename = "Vizier";
		if(target.trim().equals("")) {
			aladin.execCommand("get VizieR()");
			return null;
		}
		else
			planename += "."+target;
		
		if(!cat.trim().equals(""))
			planename += "."+cat;
		
		String cmd = "get VizieR("+cat+") "+target;
		if(radius!=null && !radius.trim().equals("")) {
			cmd += " "+radius;
			planename += "."+radius;
		}
		
		// Changes name
		cmd = planename+"="+cmd;
		
		// ** Executes the command line
		String error = aladin.execCommand(cmd);
		
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(error!=null && !error.trim().equals(""))
			System.out.println("Aladin error :"+error);
		

		System.out.println("planename : "+planename);
		if(planename!=null)
			table.put("result plane", planename);
		else
			return null;
		
//        table.put("result plane", cat);
		
		return table;
	}

}
