package jlowplugin.server.service;

import java.util.HashMap;

import jlowplugin.ui.ScriptPane;

import cds.aladin.Aladin;
import cds.aladin.Tok;
import cds.jlow.descriptor.ITaskDescriptor;
import cds.jlow.server.net.service.*;

public class RGB extends AbstractService {

	public static int next = 0;
	public Aladin aladin;

	private ScriptPane scriptPane;
	
	public RGB(Aladin aladin) {
		this(aladin, null);
	}

	public RGB(Aladin aladin, ScriptPane s) {
		this.aladin = aladin;
		scriptPane = s;
	}

	public HashMap execute(ITaskDescriptor desc, HashMap params) {
		HashMap table = new HashMap();
		
		String red = (String) params.get("red component");
		String green = (String) params.get("green component");
		String blue = (String) params.get("blue component");

		if(red==null || green==null || blue==null)
			return null;
		
		String planename = "RGB"+((next>0) ? "~"+next : "");
		next++;
		
//		System.out.println("planename = "+planename);
//		String cmd = "rgb ";
//		if(red!=null && !red.trim().equals(""))
//			cmd += " "+quote(red);
//		if(green!=null && !green.trim().equals(""))
//			cmd += " "+quote(green);
		
		String cmd = "sync; "+planename+"=rgb " + Tok.quote(red) + " " + Tok.quote(green)
			+ " " + Tok.quote(blue);
		
		String error = aladin.execCommand(cmd);
		
		if(scriptPane!=null)
			scriptPane.append(cmd);
		
		if(error!=null && !error.trim().equals(""))
			System.out.println("Aladin error : "+error);
		

//		Wait until plane found ??
//		table.put("result plane", planename);
		table.put("result plane", "RGB img");
		
		return table;
	}

//	public String quote(String s) {
//		char a[] = s.toCharArray();
//		for (int i = 0; i < a.length; i++) {
//			if (Character.isWhitespace(a[i]))
//				return "\"" + s + "\"";
//		}
//		return s;
//	}

}
