package jlowplugin.ui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.*;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;

import cds.jlow.client.graph.Jlow;

public class HelpContentsDialog extends JDialog {

	private JEditorPane textpane;
	private JEditorPane contentspane;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public HelpContentsDialog(Frame owner) {
		super(owner, true);
		
		Container c = getContentPane();
		c.setLayout(new BorderLayout());
		
		JScrollPane scrollPaneContents = null;
		JScrollPane scrollPaneText = null;
		try {
			File file = new File("resources/help/html/Contents.html");
			URL url = null; 
			if(file.exists())
				url = new URL("file:"+file.getAbsolutePath());
			else
				url = this.getClass().getResource("/help/html/Contents.html");
			
			contentspane = new JEditorPane(url);
			contentspane.addHyperlinkListener(new Hyperactive());
			contentspane.setEditable(false);
			
			//ScrollBar
			scrollPaneContents = new JScrollPane(contentspane);
			
//			c.add(scrollPaneContents,"West");
			
			file = new File("resources/help/html/UserGuide.html");
			if(file.exists())
				url = new URL("file:"+file.getAbsolutePath()); 
			else
				url = this.getClass().getResource("/help/html/UserGuide.html");
			
			textpane = new JEditorPane(url);
			textpane.addHyperlinkListener(new Hyperactive());
			textpane.setEditable(false);
			
			//ScrollBar
			scrollPaneText = new JScrollPane(textpane);
			
//			c.add(scrollPaneText,"Center");
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		JSplitPane splitpane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, scrollPaneContents, scrollPaneText);
		splitpane.setContinuousLayout(false);
		splitpane.setOneTouchExpandable(false);
		splitpane.setDividerLocation(260);
		splitpane.setDividerSize(4);
		
		c.add(splitpane, "Center");
		
		JPanel buttonPanel = new JPanel();
        JButton bOk = new JButton("OK");
        bOk.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    setVisible(false);
                }
            });
        buttonPanel.add(bOk);
        
        add(buttonPanel, "South");
		
		setTitle("Help Contents");
//		pack();
		setLocation(200,200);
		setSize(new Dimension(900, 700));
	}
	
	class Hyperactive implements HyperlinkListener {
		 
		public void hyperlinkUpdate(HyperlinkEvent e) {
//			System.out.println("hyperlink");
			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
//				final JEditorPane pane = (JEditorPane) e.getSource();
				if (e instanceof HTMLFrameHyperlinkEvent) {
					HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
					HTMLDocument doc = (HTMLDocument)textpane.getDocument();
					doc.processHTMLFrameHyperlinkEvent(evt);
				} else {
//					System.out.println("url : "+e.getURL());
//					System.out.println("description : "+e.getDescription());
					final String desc = e.getDescription();
									
					if(desc!=null && desc.startsWith("#")) {
						SwingUtilities.invokeLater(new Runnable() {
							public void run() {
//									System.out.println("scrollToReference : "+desc.substring(1));
//									System.out.println("url description : "+desc);
									textpane.scrollToReference(desc.substring(1));
							}
							});
					}
					else {
						try {
							textpane.setPage(e.getURL());
						} catch (Throwable t) {
							t.printStackTrace();
						}
					}
				}
			}
		}
    }
}
